clc
clear 
format long g
format compact

tic;%stopky

fid = fopen('ga12_u03.txt','w+'); %vstupn soubor
%fid = 1;

mi = 1 + 0.002737909; % konstanta (1 + mi)
w = 10; %w = krok tabulek pro dan katalog

zadani; %vstupni data


% druha diference ... delta +0.5
diference_RA2  = (( diference_RA(:,2)  - diference_RA(:,1)  ) + ( diference_RA(:,3)  - diference_RA(:,2)  )) / 2;
diference_DEC2 = (( diference_DEC(:,2) - diference_DEC(:,1) ) + ( diference_DEC(:,3) - diference_DEC(:,2) )) / 2;

% cas mereni prepocten na Green
t_gr = (S0 + UTC * mi) - hvezda_tab_RA;

% pocet dni mezi zadanm a nejblizsm 
D_d = D - D0;

% n ... ve vzorci mus bt vse zadvan ve dnech
n = (D_d + t_gr * rod) / w;

% opravy z krtkoperiodick nutace
dalfa  = dalfa_dpsi  * dpsi + dalfa_deps  * deps;%%%
ddelta = ddelta_dpsi * dpsi + ddelta_deps * deps;

% interpolace
hvezda_RA  = dalfa(:,1)  + hvezda_tab_RA(:,1)  + n .* diference_RA(:,2)  + 0.5 .* n .* (n - 1) .* diference_RA2(:,1);
hvezda_DEC = ddelta(:,1) + hvezda_tab_DEC(:,1) + n .* diference_DEC(:,2) + 0.5 .* n .* (n - 1) .* diference_DEC2(:,1);

fprintf(fid,'   Gaussova metoda urceni zemepisnych souradnic     \n');
fprintf(fid,'   ====================================     \n\n');
fprintf(fid,'  interpolace rektascenze a deklinace z astr. rocenky   \n\n');

fprintf(fid,'   hvezda %.f\n',hvezda(1));
fprintf(fid,' rektascenze  R.A. = %2.0f:%02.f:%06.3f\n',c2dms(roh*hvezda_RA(1)));
fprintf(fid,'   deklinace  Dec. = %2.0f%02.f''%06.3f''''\n\n',c2dms(ro*hvezda_DEC(1)));

fprintf(fid,'   hvezda %.f\n',hvezda(2));
fprintf(fid,' rektascenze  R.A. = %2.0f:%02.f:%06.3f\n',c2dms(roh*hvezda_RA(2)));
fprintf(fid,'   deklinace  Dec. = %2.0f%02.f''%06.3f''''\n\n',c2dms(ro*hvezda_DEC(2)));

fprintf(fid,'   hvezda %.f\n',hvezda(3));
fprintf(fid,' rektascenze  R.A. = %2.0f:%02.f:%06.3f\n',c2dms(roh*hvezda_RA(3)));
fprintf(fid,'   deklinace  Dec. = %2.0f%02.f''%06.3f''''\n\n',c2dms(ro*hvezda_DEC(3)));


C1 = (cos(hvezda_DEC(1)) * cos(t_gr(1)) - cos(hvezda_DEC(2)) * cos(t_gr(2))) / (sin(hvezda_DEC(1)) - sin(hvezda_DEC(2)));
C2 = (cos(hvezda_DEC(1)) * cos(t_gr(1)) - cos(hvezda_DEC(3)) * cos(t_gr(3))) / (sin(hvezda_DEC(1)) - sin(hvezda_DEC(3)));

S1=(  cos(hvezda_DEC(2)) * sin(t_gr(2)) - cos(hvezda_DEC(1)) * sin(t_gr(1))) / (sin(hvezda_DEC(1)) - sin(hvezda_DEC(2)));
S2=(  cos(hvezda_DEC(3)) * sin(t_gr(3)) - cos(hvezda_DEC(1)) * sin(t_gr(1))) / (sin(hvezda_DEC(1)) - sin(hvezda_DEC(3)));

lamda = atan2(C1-C2,S2-S1);
if(lamda < 0)
    lamda = lamda + 2*pi;
end

%-- predbezny vpocet kvuli kvadrantu
fi1 = atan( (cos(hvezda_DEC(3)) * cos(t_gr(3) + lamda) - cos(hvezda_DEC(1)) * cos(t_gr(1) + lamda)) / ( sin(hvezda_DEC(1)) - sin(hvezda_DEC(3))));
fi2 = atan( (cos(hvezda_DEC(2)) * cos(t_gr(2) + lamda) - cos(hvezda_DEC(1)) * cos(t_gr(1) + lamda)) / ( sin(hvezda_DEC(1)) - sin(hvezda_DEC(2))));

ti = t_gr + lamda;

z1 = acos( sin(fi1) * sin(hvezda_DEC(1)) + cos(fi1) * cos(hvezda_DEC(1)) * cos(ti(1)) );
z2 = acos( sin(fi1) * sin(hvezda_DEC(2)) + cos(fi1) * cos(hvezda_DEC(2)) * cos(ti(2)) );
z3 = acos( sin(fi1) * sin(hvezda_DEC(3)) + cos(fi1) * cos(hvezda_DEC(3)) * cos(ti(3)) );
%--

if (ro*z1 > 90) %nov vpocet pokud je zenitka > 90
    lamda = lamda - pi;
    
    fi1 = atan( (cos(hvezda_DEC(3)) * cos(t_gr(3) + lamda) - cos(hvezda_DEC(1)) * cos(t_gr(1) + lamda)) / ( sin(hvezda_DEC(1)) - sin(hvezda_DEC(3))));
    fi2 = atan( (cos(hvezda_DEC(2)) * cos(t_gr(2) + lamda) - cos(hvezda_DEC(1)) * cos(t_gr(1) + lamda)) / ( sin(hvezda_DEC(1)) - sin(hvezda_DEC(2))));

    ti = t_gr + lamda;

    z1 = acos( sin(fi1) * sin(hvezda_DEC(1)) + cos(fi1) * cos(hvezda_DEC(1)) * cos(ti(1)) );
    z2 = acos( sin(fi1) * sin(hvezda_DEC(2)) + cos(fi1) * cos(hvezda_DEC(2)) * cos(ti(2)) );
    z3 = acos( sin(fi1) * sin(hvezda_DEC(3)) + cos(fi1) * cos(hvezda_DEC(3)) * cos(ti(3)) );
end

fprintf(' Kontrola vsledku:\n\n');
fprintf('   fi1 = %3.f%02.f''%08.5f''''\n',c2dms(ro*fi1));
fprintf('   fi2 = %3.f%02.f''%08.5f''''\n\n',c2dms(ro*fi2));

fprintf('    z1 = %3.f%02.f''%08.5f''''\n',c2dms(ro*z1));
fprintf('    z2 = %3.f%02.f''%08.5f''''\n',c2dms(ro*z2));
fprintf('    z3 = %3.f%02.f''%08.5f''''\n',c2dms(ro*z3));

fprintf(fid,' urcovan bod:\n\n');
fprintf(fid,'    fi = %2.0f%02.f''%06.3f''''\n\n',c2dms(ro*fi1)); 


fprintf(fid,' lamda = %2.0f:%02.f:%06.3f\n',c2dms(roh*lamda));
fprintf(fid,' lamda = %2.0f%02.f''%06.3f''''\n\n',c2dms(ro*lamda));


fprintf(fid,' zenitka almukantaratu:\n\n');
fprintf(fid,'     z = %2.0f%02.f''%06.3f''''\n\n',c2dms(ro*z1)); 


fprintf(fid,' C12 = %5.9f  S12 = %5.9f \n\n',C1,S1);
fprintf(fid,' C13 = %5.9f  S13 = %5.9f \n\n',C2,S2);

fclose(fid);

fprintf('\n\nCseln vsledky jsou ulozeny v souboru "ga12_u03.txt" v pracovnm adresri\n\n');
fprintf('\ncelkov cas vpoctu %.2f vterin\n',toc);